/**

 @Name：layui.window 窗口组件
 @Author：邵阿南
 @License：MIT
    
 */

Yui.define(['layer'], function(exports) {
    'use strict';
    
    var $ = Yui.$
    ,layer = Yui.layer
    ,MOD_NAME = 'windows';
    
    var Wins = function(){
        this.wins = 'windows';
        var that = this;
        this.open = function(options){
            if(options){
                if(options.containerId){
                    if(typeof options.containerId != 'string') return;
                    var ct = $("#"+options.containerId).closest(".yui-layer.yui-layer-page");
                    options.container = ct.length?ct:$("#"+options.containerId);
                    delete options.containerId;
                }else{
                    options.container = document.body;
                }
                //处理窗口在最下化状态下点击桌面图标的情况，显示窗口
                if(that.indexStore[options.id]){
                    var tindex = that.getIndex(options.id);
                    if(!$('#yui-layer'+tindex+'_tab').hasClass('dockTopTab')){
                        $('#yui-layer'+tindex+'_tab').trigger('click');
                    }
                    return;
                }
            
                var defaultOpts = {
                    zIndex: layer.zIndex,
                    success: function(layero,index){
                        // if(!options.container || options.modal){
                        //     layer.setTop(layero);
                        //     that.storeIndex(options.id,index);
                        // }
                        if($('#yui-layer'+index+'_tab').length){
                            layer.setTop(layero);
                            that.storeIndex(options.id,index);
                        }
                        else{
                            that.storeOtherIndex(options.id,index);
                        }
                        options.success && options.success(layero,index);
                    },
                    end: function(){
                        that.removeIndex(options.id);
                        that.removeOtherIndex(options.id);
                        options.end && options.end();
                    }
                };
        
                switch(options.type){
                    case 'xhr':
                        defaultOpts.type = 1;
                        if(options.contentURL && !options.content){
                            $.ajax({
                                url:options.contentURL,
                                type:'GET',
                                timeout:30000,
                                success:function(data){
                                    defaultOpts.content = data;
                                    var opts = $.extend({},options,defaultOpts);
                                    delete options.contentURL;
                                    return layer.open(opts);
                                },
                                error:function(e){
                                    throw Error(e);
                                }
                            });
                        }else if(!options.contentURL && options.content){
                            defaultOpts.content = options.content;
                            delete options.content;
                            return layer.open($.extend({},options,defaultOpts));
                        }else{
                            throw Error("arguments 'content' or 'contentURL' is necessary!")
                        }
                    break;
                    case 'iframe':
                        defaultOpts.type = 2;
                        if(options.contentURL){
                            defaultOpts.content = options.contentURL;
                            delete options.contentURL;
                            return layer.open($.extend({},options,defaultOpts));
                        }
                        else{
                            throw Error("expect contentURL argument as url;");
                        }
                    break;
                    default:
                    throw Errow("expect argument type: 'xhr' or 'iframe' ");
                }
            }
        }
    }
    Wins.prototype = {
            
        //存储打开窗口的id及对应的index
        indexStore : {},
        otherIndexStore : {},
        storeIndex : function(id,index){
            if(id in this.indexStore){
                return;
            }
            this.indexStore[id] = index;
        },
        //存储非一级窗口的index
        storeOtherIndex : function(id,index){
            if(id in this.otherIndexStore){
                return;
            }
            this.otherIndexStore[id] = index;
        },
        //通过id获取窗口index
        getIndex : function(id){
            if(id in this.indexStore){
                return this.indexStore[id]
            }
            return undefined;
        },
        //删除窗口id及对应的index
        removeIndex : function(id){
            if(id in this.indexStore){
                delete this.indexStore[id];
            }
        },
        removeOtherIndex : function(id){
            if(id in this.otherIndexStore){
                delete this.otherIndexStore[id];
            }
        },
        //通过id关闭窗口
        closeWindowById : function(id){
            if(id in this.indexStore){
                layer.close(this.indexStore[id]);
                return;
            }
            if(id in this.otherIndexStore){
                layer.close(this.otherIndexStore[id]);
                return;
            }
        },
        //获取窗口实例
        getInstance: function(id){
            var inst = {};
            if(!id) return inst;
            var w = document.getElementById(id).parentNode,
            wId = w.getAttribute('id'),
            wd = layer.dockWrapper.winsDisplayNone,
            wo = layer.dockWrapper.winsOrder;
            if(w && wId){
                if(wd.indexOf(wId) != -1){
                    inst.isMinimized = true; //窗口处于最小化状态
                }else if( wo.indexOf(wId) != (wo.length-1) ){
                    inst.isMinimized = false;
                    inst.isCollapsed = true;
                }else{
                    inst.isMinimized = false;
                    inst.isCollapsed = false;
                }
            }
            return inst;
        },
        //监听函数设置
        on: function(event, callback){
            if(typeof event != 'string') throw Error();
            var targetEvent = '';
            switch(event){
                case 'unload':
                    targetEvent = 'unload';
                break;
            }
            layer.on(targetEvent,callback);
        },

        //通过index关闭窗口
        close: function(index){
            layer.close(index);
        },
        //最小化所有
        minimizeAll : function(){
            for(var k in this.indexStore){
                layer.min(this.indexStore[k]);
            }
        },
        //最小化
        min: function(index){
            layer.min(index);
        },
        //全屏
        full: function(index){
            layer.full(index);
        },
        //还原
        restore: function(index){
            layer.restore(index);
        },
        //显示所有
        showWindowsAll : function(){
            var dnclone = [].concat(layer.dockWrapper.winsDisplayNone);
            if (!dnclone.length) return;

            for(var i=0;i<dnclone.length;i++){
                var layero = $('#'+dnclone[i]);
                layero.css('display','block');
                $('#'+dnclone[i]+'_tab').attr("data-type",'2'); //此操作在layer.js中有解释
                layer.dockWrapper.orderWins(dnclone[i],'change');
            }
        },
        //关闭所有
        closeAll : function(){
            layer.closeAll()
        },
        //
        //改变层的标题
        title : function(title, index){
            layer.title(title, index);
        },
        //重新定义层的样式
        style : function(index, cssStyle){
            layer.style(index, cssStyle);
        },
        //初始化全局配置
        config: function(options){
            layer.config(options);
        },
        //初始化就绪
        ready: function(callback){
            layer.ready(callback);
        },
        //普通信息框
        alert: function(content, options, yes){
            layer.alert(content, options, yes);
        },
        //询问框
        confirm: function(content, options, yes, cancel){
            layer.confirm(content, options, yes, cancel);
        },
        //提示框
        msg: function(content, options, end){
            layer.msg(content, options, end);
        },
        //加载层
        load: function(icon, options){
            layer.load(icon, options);
        },
        //tips层
        tips: function(content, follow, options){
            layer.tips(content, follow, options);
        }
    }
    var windows = new Wins();
    
    exports(MOD_NAME, windows);
});